<?php /* -*- PHP -*- */

require ("library.php.inc");

init_hgrepos ();

/* unitary tests */

$data = do_unit_test ("");

$hgtree = build_hg_tree (HGREPOS);

/* unitary checks */

echo "check xml output\n";
if (strlen ($data) != 0) exit (1);

function count_name_in_tree ($name, $tree) {
    $count = 0;
    foreach ($tree as $element)
        if (strcmp ($name, $element["name"]) == 0)
            $count++;
    echo "count for '$name': $count\n";
    return $count;
}

echo "check count\n";

if (count ($hgtree) != 7) exit (1);

echo "check names\n";

if (count_name_in_tree ("a", $hgtree) != 1) exit (1);
if (count_name_in_tree ("b", $hgtree) != 1) exit (1);
if (count_name_in_tree ("b/a", $hgtree) != 0) exit (1);
if (count_name_in_tree ("c", $hgtree) != 1) exit (1);
if (count_name_in_tree ("c/a", $hgtree) != 1) exit (1);
if (count_name_in_tree ("c/b", $hgtree) != 0) exit (1);
if (count_name_in_tree ("d", $hgtree) != 0) exit (1);
if (count_name_in_tree ("d/a", $hgtree) != 1) exit (1);
if (count_name_in_tree ("d/a/a", $hgtree) != 1) exit (1);
if (count_name_in_tree ("d/b", $hgtree) != 1) exit (1);

echo "check resource\n";

$resources = array("contact" => "Laurent Mazet",
                   "description" => "Mercurial Headquarters",
                   "allow_read" => null,
                   "deny_read" => null,
                   "allow_push" => null,
                   "deny_push" => null,
                   "accesslog" => null,
                   "errorlog" => null,
                   "archive_bz2" => null,
                   "archive_gz" => null,
                   "archive_zip" => null,
                   "hidden" => null,
                   "encoding" => null,
                   "style" => "gitweb");

foreach ($hgtree as $element) {
    foreach ($resources as $key => $res) {
        echo "resource for $element[name] '$key': $res\n";
        if (strcmp ($element["name"], "a") == 0) {
            if (isset ($element[$key])) {
                if ((!isset ($res)) || (strcmp ($element[$key], $res) != 0)) exit (1);
            } else {
                if (isset ($res)) exit (1);
            }
        } else {
            if (isset ($element[$key])) exit (1);
        }
    }
}

exit (0);
?>
