<?php /* -*- PHP -*- */

require ("library.php.inc");

init_hgrepos ();

/* unitary tests */

$_GET = array ("xmlconfig" => 0);

$data = do_unit_test ("");

/* Unitary checks */

$xml_parser = xml_parser_create ();
xml_parser_set_option ($xml_parser, XML_OPTION_CASE_FOLDING, 0);
xml_parser_set_option ($xml_parser, XML_OPTION_SKIP_WHITE, 1);
xml_parse_into_struct ($xml_parser, $data, $vals, $index);
xml_parser_free ($xml_parser);

echo "check number of tags\n";
if (count ($vals) != 14) exit (1);

echo "check tags\n";
for ($i = 0; $i < count ($vals); $i++) {
    switch ($vals[$i]["tag"]) {
    case "xml":
    case "config":
    case "root":
    case "name":
    case "logfile":
    case "loglevel":
    case "style":
    case "auth":
    case "authfile":
    case "authldaphost":
    case "authldaprequest":
    case "admin":
        echo "tag: " . $vals[$i]["tag"] . "\n";
        break;
    default:
        echo "unknown tag: " . $vals[$i]["tag"] . "\n";
        exit (1);
    }
}

print_r ($vals);

echo "check structure\n";
$levels = array ();
for ($i = 0; $i < count ($vals); $i++) {
    switch ($vals[$i]["type"]) {
    case "open":
        echo "open tag '" . $vals[$i]["tag"] . "'\n";
        array_push ($levels, $vals[$i]["tag"]);
        break;
    case "complete":
        echo "complete tag '" . $vals[$i]["tag"] . "'\n";
        break;
    case "close":
        $open = array_pop ($levels);
        if (strcmp ($vals[$i]["tag"], $open) != 0) {
            echo "error closing tag '" . $vals[$i]["tag"] . "' expecting '$open'\n";
            exit (1);
        }
        echo "closing tag '" . $vals[$i]["tag"] . "'\n";
        break;
    default:
        echo "unknown type: '" . $vals[$i]["type"] . "'\n";
        exit (1);
    }
}
if (count ($levels) != 0) {
    echo "xml structure not closed\n";
    print_r ($levels);
    exit (1);
}

exit (0);
?>
